"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectionItem = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const constants_1 = require("./constants");
const tree_item_1 = require("./tree-item");
const CollectionIcon = ({ type }) => {
    const glyph = (0, react_1.useMemo)(() => {
        return type === 'timeseries'
            ? 'TimeSeries'
            : type === 'view'
                ? 'Visibility'
                : 'Folder';
    }, [type]);
    return react_1.default.createElement(compass_components_1.Icon, { glyph: glyph, size: "small" });
};
const collectionItem = (0, compass_components_1.css)({
    height: constants_1.COLLECTION_ROW_HEIGHT,
});
const itemButtonWrapper = (0, compass_components_1.css)({
    height: constants_1.COLLECTION_ROW_HEIGHT,
    paddingRight: compass_components_1.spacing[1],
    paddingLeft: compass_components_1.spacing[5] + compass_components_1.spacing[1] + compass_components_1.spacing[4],
});
const collectionItemLabel = (0, compass_components_1.css)({
    marginLeft: compass_components_1.spacing[2],
});
const CollectionItem = ({ id, name, type, posInSet, setSize, isActive, isReadOnly, isTabbable, style, onNamespaceAction, }) => {
    const [hoverProps, isHovered] = (0, compass_components_1.useHoverState)();
    const onDefaultAction = (0, react_1.useCallback)((evt) => {
        onNamespaceAction(evt.currentTarget.dataset.id, 'select-collection');
    }, [onNamespaceAction]);
    const onAction = (0, react_1.useCallback)((action) => {
        onNamespaceAction(id, action);
    }, [id, onNamespaceAction]);
    const actions = (0, react_1.useMemo)(() => {
        const actions = [
            {
                action: 'open-in-new-tab',
                label: 'Open in new tab',
                icon: 'OpenNewTab',
            },
        ];
        if (isReadOnly) {
            return actions;
        }
        if (type === 'view') {
            actions.push({
                action: 'drop-collection',
                label: 'Drop view',
                icon: 'Trash',
            }, {
                action: 'duplicate-view',
                label: 'Duplicate view',
                icon: 'Copy',
            }, {
                action: 'modify-view',
                label: 'Modify view',
                icon: 'Edit',
            });
        }
        else {
            actions.push({
                action: 'drop-collection',
                label: 'Drop collection',
                icon: 'Trash',
            });
        }
        return actions;
    }, [type, isReadOnly]);
    return (react_1.default.createElement(tree_item_1.ItemContainer, { id: id, "data-testid": `sidebar-collection-${id}`, level: 2, setSize: setSize, posInSet: posInSet, isActive: isActive, isTabbable: isTabbable, onDefaultAction: onDefaultAction, style: style, className: collectionItem, ...hoverProps },
        react_1.default.createElement(tree_item_1.ItemWrapper, null,
            react_1.default.createElement(tree_item_1.ItemButtonWrapper, { className: itemButtonWrapper },
                react_1.default.createElement(CollectionIcon, { type: type }),
                react_1.default.createElement(tree_item_1.ItemLabel, { className: collectionItemLabel, title: name }, name)),
            react_1.default.createElement(compass_components_1.ItemActionControls, { onAction: onAction, "data-testid": "sidebar-collection-item-actions", iconSize: "small", isVisible: isActive || isHovered, actions: actions }))));
};
exports.CollectionItem = CollectionItem;
//# sourceMappingURL=collection-item.js.map